<?php
if ( !class_exists('IamportShortcode') ) {

	class IamportShortcode {

		private $user_code;
		private $api_key;
		private $api_secret;
		private $initialized;

		public function __construct($user_code, $api_key, $api_secret) {
			$this->user_code = $user_code;
			$this->api_key = $api_key;
			$this->api_secret = $api_secret;
			$this->initialized = false;

			$this->hook();
		}

		private function hook() {
			add_shortcode( 'iamport_payment_button', array($this, 'hook_payment_button') );
		}

		private function getUUID() {
			return uniqid('btn-iamport-payment');
		}

		public function hook_payment_button($atts, $content = null) {
			$uuid = $this->getUUID();
			$a = shortcode_atts( array(
				'pay_method' => 'card',
				'name' => '아임포트 결제하기',
				'amount' => 1004,
				'style' => 'display:inline-block;padding:6px 12px;color:#fff;background-color:#2c3e50',
				'class' => null,
			), $atts );

			if ( empty($content) )	$content = '결제하기';
			$merchant_uid = 'b_' . time() . $this->user_code;

			ob_start();
			?>
			<a id="<?=$uuid?>" href="" class="<?=$a['class']?>" style="<?=(empty($a['class']) && !empty($a['style'])) ? $a['style'] : ''?>"><?=$content?></a>
			<script type="text/javascript">
			jQuery('#<?=$uuid?>').click(function() {
				<?php
					if ( !$this->initialized ) {
						$this->initialized = true;

						echo sprintf("IMP.init('%s');\n", $this->user_code);
					}
				?>

				IMP.request_pay({
					pay_method : '<?=strip_tags($a["pay_method"])?>',
					merchant_uid : '<?=$merchant_uid?>',
					name : '<?=strip_tags($a["name"])?>',
					amount : parseInt('<?=$a["amount"]?>')
				}, function(rsp) {
					if ( rsp.success ) {
						alert('결제가 완료되었습니다.');
					} else {
						alert("결제에 실패하였습니다. 실패 사유는 다음과 같습니다.\n" + rsp.error_msg);
					}
				});

				return false;
			});
			</script>
			<?php 
			$shortcode_html = ob_get_clean();

			return $shortcode_html;
		}

	}

}